#include <Keypad.h>
#include <Servo.h>

const byte ROWS = 4;
const byte COLS = 4;
char keys[ROWS][COLS] = {
  {'1', '2', '3', 'A'},
  {'4', '5', '6', 'B'},
  {'7', '8', '9', 'C'},
  {'*', '0', '#', 'D'}
}; 
byte rowPins[ROWS] = {9, 8, 7, 6};
byte colPins[COLS] = {5, 4, 3, 2};
Keypad keypad = Keypad(makeKeymap(keys), rowPins, colPins, ROWS, COLS);

Servo motor; 
int motorPin = 10;
int motorPosition = 0; 
bool passwordEntered = false; 
unsigned long lastKeyTime; 

void setup() {
  motor.attach(motorPin);
  motor.write(motorPosition);
  Serial.begin(9600); 
}

void loop() {
  char key = keypad.getKey(); 

  if (key != NO_KEY) { 
    Serial.println(key);
    lastKeyTime = millis();

    if (key == '1') {
      passwordEntered = true; 
    }
    else if (key == '2' && passwordEntered) {
      passwordEntered = true; 
    }
    else if (key == '3' && passwordEntered) {
      passwordEntered = true; 
    }
    else if (key == '4' && passwordEntered) {
      passwordEntered = false; 
      if (motorPosition == 0) {
        motorPosition = 90; 
      }
      else {
        motorPosition = 0; 
      }
      motor.write(motorPosition);
    }
    else {
      passwordEntered = false;
    }
  }
  
  if (millis() - lastKeyTime > 90000 && motorPosition != 0) { 
    motorPosition = 0; // Set the motor position to 0 degrees
    motor.write(motorPosition); // Move the motor to the new position
  }
}

